package com.javanicus.taocp.section_1_1e;

public class EuclidsAlgorithm {

	public static int findGreatestCommonDivisor(int m, int n) {
		int r = 0;
		if (m<n) {r =m; m=n; n=r;}
		while (true) {
			r = m % n;
			if (r == 0) {return n;}
			m=n; n=r;
		}
	}

	public static int findGreatestCommonDivisorDetailed(int m, int n) {
		// initialise
		int r = 0;

		// ------------------------------------
		// *** E0. [Ensure m >= n.]
		// *** If m < n, exchange m and n.
		if (m < n) {
			int temp = m;
			m = n;
			n = temp;
		}
		while (true) {
			// *** E1. [Find remainder.]
			// *** Divide m by n and let r be the remainder.
			r = m % n;
			System.out.println("[m = " + m + "]\t[n = " + n + "]\t[r = " + r + "]");

			// *** (We will have 0 <= r < n.)
			assert 0 <= r : "r is less than zero";
			assert r < n : "r >= n";

			// *** E2. [Is it zero?]
			// *** If r == 0, the algorithm terminates; n is the answer.
			if (r == 0) {
				return n;
			}

			// *** E3. [Reduce.]
			// *** Set m = n, n = r and go back to step E1.
			m = n;
			n = r;
		} // end while

	}
}